/* A Bison parser, made by GNU Bison 2.3.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C

   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.3"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     P_NAME = 258,
     P_SEPARATOR = 259,
     P_CONST = 260,
     P_COMMENT_TEXT = 261,
     P_CAPTION_TEXT = 262,
     P_UNSIGNED_INTEGER = 263,
     ADDR = 264,
     AND = 265,
     ARRAY = 266,
     BEGIN = 267,
     BOUND = 268,
     CAPTION = 269,
     CHECKS = 270,
     CODE = 271,
     COMMENT = 272,
     COMPILE = 273,
     CYCLE = 274,
     END = 275,
     FAULT = 276,
     FN = 277,
     IF = 278,
     IGNORE = 279,
     INTEGER = 280,
     LIST = 281,
     M = 282,
     MAP = 283,
     MONITOR = 284,
     NAME = 285,
     OF = 286,
     OR = 287,
     PERM = 288,
     PROGRAM = 289,
     QUERIES = 290,
     REAL = 291,
     REPEAT = 292,
     RESULT = 293,
     RETURN = 294,
     ROUTINE = 295,
     SPEC = 296,
     STOP = 297,
     SWITCH = 298,
     THEN = 299,
     UNLESS = 300,
     IDENTIFIER = 301,
     NEWLINE = 302
   };
#endif
/* Tokens.  */
#define P_NAME 258
#define P_SEPARATOR 259
#define P_CONST 260
#define P_COMMENT_TEXT 261
#define P_CAPTION_TEXT 262
#define P_UNSIGNED_INTEGER 263
#define ADDR 264
#define AND 265
#define ARRAY 266
#define BEGIN 267
#define BOUND 268
#define CAPTION 269
#define CHECKS 270
#define CODE 271
#define COMMENT 272
#define COMPILE 273
#define CYCLE 274
#define END 275
#define FAULT 276
#define FN 277
#define IF 278
#define IGNORE 279
#define INTEGER 280
#define LIST 281
#define M 282
#define MAP 283
#define MONITOR 284
#define NAME 285
#define OF 286
#define OR 287
#define PERM 288
#define PROGRAM 289
#define QUERIES 290
#define REAL 291
#define REPEAT 292
#define RESULT 293
#define RETURN 294
#define ROUTINE 295
#define SPEC 296
#define STOP 297
#define SWITCH 298
#define THEN 299
#define UNLESS 300
#define IDENTIFIER 301
#define NEWLINE 302




/* Copy the first part of user declarations.  */
#line 1 "AAboot.y"

#include <ctype.h>
#include <stdio.h>

extern yylex();
extern yyerror(char *s);
extern int endsrc;
extern int formal_pars;
extern int lineCount;
extern char *idtable[];

extern case_flip(int p);

int block_count = 0;
extern int justz;

extern void storesyl(int p1);

extern void store2syl(int p1);
/* sstore 2-syllable instruction p1 */

extern void qnum(int q);
/* confirms that q is a valid Q-store number */

extern int twosylqx(int instr, int q1, int q2);
/* evaluate two syllable Q-store instruction with 2 Q-store numbers in it
   or one Q-store number and a specified lower byte  */

extern void store3syl(int instr, int addr);
/* takes the output from data loc and embeds in the instruction */

extern void nonums(int i1);
// process instructions with no parameters

extern void onenum(int i1, int n1);

extern int tablocate(unsigned char *s);
/* locate this character string as though it were an identifier */
/* fancy characters in instruction mnemonics need unsigned char */

extern int idtablocate(char *s, int id);
/* locate the character string formed by concatenating s and id as though it were an identifier */

extern int idtablocate2(char *s, int id1, int id2, int id3);
/* joins together all four components like previous routine, id3 can be -ve to indicate null string */

extern int jumptest(int idj, int idz, char *syn);
// handles synonyms such as J>=Z -- JGEZ
// idj must be "J" and idz "Z" for the instruction to be valid
// syn is the all-letters mnemonic that will be used for table lookup

extern int codeloc(int lab);
// get absolute address of Usercode label

extern void startnewword(int n);
// round address to multiple of n words

void twonums(int i1, int n1, int n2);
void justaddr(int i1, int a1);
void numaddr(int i1, int n1, int a1);

extern void mpmi(int i1, int pm, int i2, int n);
/* Only valid for instructions of the form M+Iq, M-Iq */

extern void setinc(int i1, int n1, int n2);
// process Iq=+1, etc

extern void qval(int n1,int n2,int n3);
// process Q-store format word



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 216 of yacc.c.  */
#line 272 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int i)
#else
static int
YYID (i)
    int i;
#endif
{
  return i;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  71
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   363

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  66
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  49
/* YYNRULES -- Number of rules.  */
#define YYNRULES  176
/* YYNRULES -- Number of states.  */
#define YYNSTATES  339

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   302

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    52,     2,    62,     2,     2,     2,     2,
      55,    56,    48,    57,    50,    53,     2,    59,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    51,    61,
      63,    49,    54,    60,    65,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,    64,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,    58,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     8,    10,    13,    14,    15,    21,    28,
      31,    37,    42,    56,    59,    63,    68,    72,    78,    83,
      88,    91,    94,    97,   101,   105,   109,   111,   115,   118,
     123,   127,   133,   135,   141,   147,   152,   156,   158,   162,
     169,   172,   176,   184,   186,   188,   193,   195,   198,   201,
     203,   205,   206,   209,   213,   217,   218,   221,   223,   228,
     231,   233,   235,   237,   239,   240,   246,   247,   252,   253,
     255,   256,   258,   259,   261,   263,   265,   267,   269,   271,
     272,   275,   278,   279,   285,   288,   289,   296,   299,   300,
     310,   313,   314,   316,   319,   322,   325,   328,   330,   334,
     335,   339,   342,   343,   346,   350,   353,   358,   360,   364,
     368,   370,   373,   376,   377,   380,   383,   384,   391,   395,
     399,   400,   402,   404,   407,   409,   412,   414,   421,   424,
     425,   428,   429,   431,   433,   436,   440,   444,   450,   456,
     460,   466,   468,   471,   474,   478,   483,   488,   494,   500,
     507,   513,   517,   521,   526,   531,   537,   543,   548,   553,
     557,   561,   565,   567,   570,   572,   575,   577,   580,   585,
     590,   596,   602,   607,   613,   614,   616
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      67,     0,    -1,    68,    20,    31,    34,    -1,    72,    -1,
      68,    72,    -1,    -1,    -1,    69,    48,   112,    70,   111,
      -1,    71,    69,    48,   112,    70,   111,    -1,    73,   111,
      -1,    83,   100,    44,    73,   111,    -1,    73,    83,   100,
     111,    -1,    19,    46,    79,    49,    74,    75,    50,    74,
      75,    50,    74,    75,   111,    -1,    37,   111,    -1,    84,
      86,   111,    -1,    85,    11,    88,   111,    -1,    43,    92,
     111,    -1,    94,    41,    46,    96,   111,    -1,    41,    46,
      96,   111,    -1,    94,    46,    96,   111,    -1,    12,   111,
      -1,    20,   111,    -1,     8,    51,    -1,    46,   113,    51,
      -1,    18,    35,   111,    -1,    24,    35,   111,    -1,    17,
      -1,    52,     6,   111,    -1,    26,   111,    -1,    20,    31,
      26,   111,    -1,    27,    16,   111,    -1,    20,    31,    27,
      16,   111,    -1,    71,    -1,    18,    11,    13,    15,   111,
      -1,    24,    11,    13,    15,   111,    -1,    20,    31,    33,
     111,    -1,    21,   108,   111,    -1,   111,    -1,     8,    46,
      51,    -1,    46,   113,    49,    74,    75,    81,    -1,    46,
     113,    -1,    53,    54,     8,    -1,    53,    54,    46,    55,
      74,    75,    56,    -1,    14,    -1,    39,    -1,    38,    49,
      74,    75,    -1,    42,    -1,    29,    42,    -1,    29,     8,
      -1,    57,    -1,    53,    -1,    -1,    77,    76,    -1,    58,
      77,    58,    -1,    78,    77,    76,    -1,    -1,    46,    79,
      -1,   114,    -1,    55,    74,    75,    56,    -1,    48,    48,
      -1,    57,    -1,    53,    -1,    48,    -1,    59,    -1,    -1,
      55,    74,    75,    80,    56,    -1,    -1,    50,    74,    75,
      80,    -1,    -1,    60,    -1,    -1,    50,    -1,    -1,    23,
      -1,    45,    -1,    25,    -1,    36,    -1,    25,    -1,    36,
      -1,    -1,    46,    87,    -1,    50,    86,    -1,    -1,    86,
      55,    90,    56,    89,    -1,    50,    88,    -1,    -1,    74,
      75,    51,    74,    75,    91,    -1,    50,    90,    -1,    -1,
      86,    55,    74,   114,    51,    74,   114,    56,    93,    -1,
      50,    92,    -1,    -1,    40,    -1,    36,    22,    -1,    25,
      22,    -1,    36,    28,    -1,    25,    28,    -1,    55,    -1,
      95,    97,    56,    -1,    -1,    99,    86,    98,    -1,    61,
      97,    -1,    -1,    82,    94,    -1,    82,    84,    30,    -1,
      82,    84,    -1,    82,    85,    11,    30,    -1,     9,    -1,
     105,    10,   101,    -1,   105,    32,   103,    -1,   105,    -1,
     105,   102,    -1,    10,   101,    -1,    -1,   105,   104,    -1,
      32,   103,    -1,    -1,    74,    75,   107,    74,    75,   106,
      -1,    55,   103,    56,    -1,   107,    74,    75,    -1,    -1,
      49,    -1,    62,    -1,    63,    49,    -1,    63,    -1,    54,
      49,    -1,    54,    -1,     8,   109,    53,    54,     8,   110,
      -1,    50,     8,    -1,    -1,    50,   108,    -1,    -1,    61,
      -1,    47,    -1,    46,    51,    -1,    46,     8,    51,    -1,
      46,    46,     8,    -1,    70,    48,    64,    46,   113,    -1,
      70,    48,    65,    46,   113,    -1,    70,    48,    77,    -1,
      70,    48,    49,    46,   113,    -1,    46,    -1,    49,    46,
      -1,    46,     8,    -1,    49,    46,     8,    -1,    49,    57,
      46,     8,    -1,    46,     8,    46,     8,    -1,    49,    46,
       8,    46,     8,    -1,    46,     8,    46,     8,    46,    -1,
      49,    46,     8,    46,     8,    46,    -1,    46,     8,    46,
      46,     8,    -1,    46,    53,     8,    -1,    46,    57,     8,
      -1,    46,     8,    49,    46,    -1,    46,     8,    54,    46,
      -1,    46,     8,    54,    49,    46,    -1,    46,     8,    63,
      49,    46,    -1,    46,     8,    63,    46,    -1,    46,     8,
      62,    46,    -1,    46,     8,    62,    -1,    46,     8,    49,
      -1,    46,     8,    46,    -1,    53,    -1,    53,    46,    -1,
      57,    -1,    57,    46,    -1,    59,    -1,    59,    46,    -1,
      46,    53,    46,     8,    -1,    46,    57,    46,     8,    -1,
      46,     8,    49,    53,     8,    -1,    46,     8,    49,    57,
       8,    -1,    46,     8,    49,     8,    -1,     8,    59,     8,
      59,     8,    -1,    -1,    79,    -1,     8,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   130,   130,   133,   134,   137,   140,   144,   145,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   181,
     182,   183,   184,   186,   187,   188,   189,   190,   191,   194,
     195,   196,   199,   200,   204,   205,   209,   210,   211,   217,
     218,   219,   220,   221,   223,   226,   227,   230,   231,   234,
     235,   238,   239,   242,   243,   246,   247,   250,   251,   252,
     255,   258,   259,   262,   265,   266,   269,   272,   273,   276,
     279,   280,   283,   284,   285,   286,   287,   290,   292,   293,
     296,   299,   300,   303,   304,   305,   306,   307,   310,   311,
     312,   316,   319,   320,   323,   326,   327,   330,   331,   334,
     335,   338,   339,   340,   341,   342,   343,   346,   349,   350,
     353,   354,   362,   363,   366,   368,   369,   371,   372,   373,
     374,   376,   377,   378,   379,   380,   382,   384,   387,   389,
     392,   395,   396,   398,   399,   400,   401,   402,   403,   404,
     405,   406,   408,   409,   410,   411,   412,   413,   414,   415,
     417,   418,   419,   421,   424,   427,   430
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "P_NAME", "P_SEPARATOR", "P_CONST",
  "P_COMMENT_TEXT", "P_CAPTION_TEXT", "P_UNSIGNED_INTEGER", "ADDR", "AND",
  "ARRAY", "BEGIN", "BOUND", "CAPTION", "CHECKS", "CODE", "COMMENT",
  "COMPILE", "CYCLE", "END", "FAULT", "FN", "IF", "IGNORE", "INTEGER",
  "LIST", "M", "MAP", "MONITOR", "NAME", "OF", "OR", "PERM", "PROGRAM",
  "QUERIES", "REAL", "REPEAT", "RESULT", "RETURN", "ROUTINE", "SPEC",
  "STOP", "SWITCH", "THEN", "UNLESS", "IDENTIFIER", "NEWLINE", "'*'",
  "'='", "','", "':'", "'!'", "'-'", "'>'", "'('", "')'", "'+'", "'|'",
  "'/'", "'?'", "';'", "'#'", "'<'", "'`'", "'@'", "$accept", "program",
  "statements", "flip_case1", "flip_case0", "machine_code_sequence",
  "single_statement", "unconditional_instrn", "plus_p", "exprn",
  "rest_of_exprn", "operand", "operator", "actual_parameters_p",
  "rest_of_actual_parameters", "query_p", "comma_p", "if_or_unless",
  "type", "type_p", "name_list", "rest_of_name_list", "array_list",
  "rest_of_array_list", "bound_pair_list", "rest_of_bp_list",
  "switch_list", "rest_of_switch_list", "rt", "fp_start",
  "formal_parameter_defn_p", "fp_list", "rest_of_fp_list", "fp_delimiter",
  "condition", "and_cond", "rest_of_and_cond", "or_cond",
  "rest_of_or_cond", "simple_cond", "rest_of_simple_cond", "comparator",
  "fault_list", "rest_of_N_list", "rest_of_fault_list", "separator",
  "machine_instrn", "actual_parameters", "constant", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,    42,    61,
      44,    58,    33,    45,    62,    40,    41,    43,   124,    47,
      63,    59,    35,    60,    96,    64
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    66,    67,    68,    68,    69,    70,    71,    71,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    72,
      72,    72,    72,    72,    72,    72,    72,    72,    72,    73,
      73,    73,    73,    73,    73,    73,    73,    73,    73,    74,
      74,    74,    75,    75,    76,    76,    77,    77,    77,    78,
      78,    78,    78,    78,    78,    79,    79,    80,    80,    81,
      81,    82,    82,    83,    83,    84,    84,    85,    85,    85,
      86,    87,    87,    88,    89,    89,    90,    91,    91,    92,
      93,    93,    94,    94,    94,    94,    94,    95,    96,    96,
      97,    98,    98,    99,    99,    99,    99,    99,   100,   100,
     100,   101,   102,   102,   103,   104,   104,   105,   105,   106,
     106,   107,   107,   107,   107,   107,   107,   108,   109,   109,
     110,   110,   111,   111,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   112,   112,   112,   112,   112,
     112,   112,   112,   112,   112,   113,   114
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     4,     1,     2,     0,     0,     5,     6,     2,
       5,     4,    13,     2,     3,     4,     3,     5,     4,     4,
       2,     2,     2,     3,     3,     3,     1,     3,     2,     4,
       3,     5,     1,     5,     5,     4,     3,     1,     3,     6,
       2,     3,     7,     1,     1,     4,     1,     2,     2,     1,
       1,     0,     2,     3,     3,     0,     2,     1,     4,     2,
       1,     1,     1,     1,     0,     5,     0,     4,     0,     1,
       0,     1,     0,     1,     1,     1,     1,     1,     1,     0,
       2,     2,     0,     5,     2,     0,     6,     2,     0,     9,
       2,     0,     1,     2,     2,     2,     2,     1,     3,     0,
       3,     2,     0,     2,     3,     2,     4,     1,     3,     3,
       1,     2,     2,     0,     2,     2,     0,     6,     3,     3,
       0,     1,     1,     2,     1,     2,     1,     6,     2,     0,
       2,     0,     1,     1,     2,     3,     3,     5,     5,     3,
       5,     1,     2,     2,     3,     4,     4,     5,     5,     6,
       5,     3,     3,     4,     4,     5,     5,     4,     4,     3,
       3,     3,     1,     2,     1,     2,     1,     2,     4,     4,
       5,     5,     4,     5,     0,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       5,     0,     0,    43,    26,     0,     0,     0,     0,    73,
       0,    75,     0,     0,     0,    76,     0,     0,    44,    92,
       0,    46,     0,    74,    66,   133,     0,     0,   132,     0,
       5,     0,    32,     3,     0,    51,     0,     0,     0,    37,
       0,    22,    20,     0,     0,    66,     0,    21,   129,     0,
       0,     0,    94,    96,    28,     0,    48,    47,    93,    95,
      13,    51,    99,    82,     0,     0,    51,   175,    40,     0,
       0,     1,     0,     4,   174,     0,    51,     9,    50,    51,
      49,     0,     0,   110,     0,     0,     0,    99,    38,     0,
      24,     0,     0,     0,     0,     0,     0,    36,     0,    25,
      30,     0,    97,    72,     0,     0,    80,    51,    16,     0,
      51,    23,    27,    41,     0,     0,     0,   141,     0,   162,
     164,   166,     0,     6,   174,     0,     0,   116,   176,    66,
      51,     0,     0,    55,    57,     0,    51,    51,    14,     0,
       0,    99,     0,     0,    51,    29,     0,    35,   128,     0,
       0,    45,   107,    71,    79,     0,     0,    18,    81,     0,
      68,     0,    51,     2,     0,   143,     0,   134,     0,     0,
     142,     0,   163,   165,   167,     0,     0,     6,    11,   118,
      51,   114,    56,     0,     0,   121,   126,   122,   124,    51,
      62,    61,    60,    63,    52,     0,    66,     0,   108,   113,
     109,    51,    15,     0,    19,    33,     0,    31,     0,    34,
     105,     0,   103,    98,   102,     0,    51,     0,    70,     0,
       0,   161,   160,   135,     0,   159,     0,   136,   151,     0,
     152,     0,   144,     0,     0,     0,     0,   139,     7,     0,
     115,     0,    53,   125,   123,     0,    59,    55,    40,    10,
      51,   111,     0,     0,    17,     0,   131,   104,     0,    72,
     100,    51,     0,    65,    69,    39,     0,     0,   146,     0,
     172,   153,     0,     0,   154,     0,   158,   157,     0,   168,
     169,     0,   145,    66,    66,    66,     8,    58,   120,    54,
     112,     0,    85,    51,     0,   127,   106,   101,     0,    68,
      42,   173,   148,   150,   170,   171,   155,   156,   147,   140,
     137,   138,   117,    51,    51,     0,    83,     0,   130,     0,
      67,   149,     0,     0,    84,     0,    91,   119,    88,    51,
       0,    89,    51,    86,     0,    90,    87,     0,    12
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,    29,    30,    31,   122,    32,    33,    34,    81,   132,
     194,   133,   195,    67,   217,   265,   154,    35,    36,    37,
      64,   106,   140,   316,   253,   333,    65,   331,    38,   103,
     104,   155,   260,   156,    82,   198,   251,   126,   181,   127,
     312,   189,    49,    96,   295,    39,   123,    68,   134
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -190
static const yytype_int16 yypact[] =
{
     146,   -21,    69,  -190,  -190,     5,    91,   -23,   134,  -190,
     101,   104,    69,   137,    79,   128,    69,   106,  -190,  -190,
     113,  -190,   122,  -190,   123,  -190,   175,   136,  -190,   194,
     268,   155,   156,  -190,     3,    94,   122,   198,    87,  -190,
     161,  -190,  -190,   202,    69,   123,     2,  -190,   166,    69,
     206,    69,  -190,  -190,  -190,    69,  -190,  -190,  -190,  -190,
    -190,    60,   170,   179,   172,    69,    60,  -190,   159,    69,
      12,  -190,    -4,  -190,    52,   184,    94,  -190,  -190,    94,
    -190,    33,   186,     7,    69,   122,   187,   170,  -190,   221,
    -190,   195,    69,   227,    69,   237,   193,  -190,   232,  -190,
    -190,    33,  -190,     4,    69,   122,  -190,    60,  -190,    33,
      60,  -190,  -190,  -190,   196,   215,   191,    57,   -12,   207,
     208,   209,   204,  -190,    52,    69,   200,   225,  -190,   123,
      60,    38,   177,    72,  -190,   182,    94,    94,  -190,   205,
      69,   170,    69,    69,    60,  -190,    69,  -190,  -190,   210,
      69,  -190,  -190,  -190,    -3,   211,   122,  -190,  -190,   253,
     212,    33,    60,  -190,   255,   151,   257,  -190,    23,    78,
     258,   222,  -190,  -190,  -190,    13,    69,  -190,  -190,  -190,
      94,  -190,  -190,    33,   213,  -190,   220,  -190,   223,    60,
     230,  -190,  -190,  -190,  -190,    38,   123,    69,  -190,   260,
    -190,    60,  -190,    69,  -190,  -190,    33,  -190,   265,  -190,
     245,   272,  -190,  -190,   229,   233,    60,   240,   238,    33,
     241,    89,    28,  -190,   130,   256,   131,  -190,  -190,   291,
    -190,   293,   266,   295,   270,   271,   273,  -190,  -190,    69,
    -190,   262,  -190,  -190,  -190,    33,  -190,    72,   274,  -190,
      94,  -190,    33,   269,  -190,   276,   277,  -190,   292,     4,
    -190,    60,    33,  -190,  -190,  -190,   275,   316,   282,   322,
    -190,  -190,   324,   325,  -190,   288,  -190,  -190,   290,  -190,
    -190,   329,  -190,   123,   123,   123,  -190,  -190,   177,  -190,
    -190,   287,   289,    60,   134,  -190,  -190,  -190,   253,   212,
    -190,  -190,  -190,  -190,  -190,  -190,  -190,  -190,   294,  -190,
    -190,  -190,  -190,    60,    60,   122,  -190,    33,  -190,   285,
    -190,  -190,    33,    33,  -190,   296,   297,  -190,   298,    60,
     122,  -190,    60,  -190,    33,  -190,  -190,    69,  -190
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -190,  -190,  -190,   310,  -105,  -190,   313,   214,   -55,  -100,
      97,  -119,  -190,   -30,    46,  -190,  -190,   317,   199,   201,
     -34,  -190,    35,  -190,    20,  -190,    24,  -190,   203,  -190,
     -68,    99,  -190,  -190,   280,   109,  -190,  -114,  -190,   -32,
    -190,    73,    66,  -190,  -190,    -2,   239,  -189,  -155
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -80
static const yytype_int16 yytable[] =
{
      42,   151,    84,    83,   215,    47,   101,   248,    46,   160,
      54,   109,   184,   152,    60,    91,    43,   136,   176,   142,
     113,   128,    11,   200,    25,    40,     9,   115,    92,    93,
      41,   228,    77,    15,   170,    94,   270,    19,    28,   137,
      44,   128,    90,    25,    83,   171,   128,    97,    23,    99,
      25,   139,   159,   100,   153,   161,   237,    28,   114,   129,
     116,   218,   234,   108,    28,   165,   240,   112,   130,   229,
      47,   158,   239,   203,   271,   183,   247,   235,   236,   129,
     -64,   272,   138,   241,   129,   273,   230,    56,   130,   206,
     145,   131,   147,   130,   309,   310,   311,   268,   117,   182,
      -6,   118,   157,   166,   199,   119,   255,   219,   167,   120,
     168,   121,    50,    78,   169,   -77,    25,    80,   -64,   266,
     190,    57,   214,   178,   231,   191,    52,   -64,    86,   192,
      28,   193,    53,    87,   245,   269,    51,    45,   202,   -78,
     204,   205,    48,   319,   207,   288,   252,    78,   209,    79,
      58,    80,   291,    55,     1,    61,    59,   -79,     2,    62,
       3,   262,   299,     4,     5,     6,     7,     8,    63,     9,
      10,    11,    12,    13,   238,    14,   274,   277,    66,   275,
     278,    69,    15,    16,    17,    18,    19,    20,    21,    22,
      70,    23,    24,    25,    71,   249,     3,   221,    26,    27,
     222,   254,   223,    74,    -5,   224,   298,    28,   110,    85,
     111,    14,    88,   225,   226,    89,    95,   325,   199,    98,
      17,    18,   327,   328,    21,   102,   185,   107,   196,   105,
     135,   186,   124,   141,   337,    27,   143,   286,   317,   187,
     188,    92,    93,   146,   144,   148,   149,   150,    94,   163,
     164,   162,   175,   172,   173,   174,   179,   180,   322,   323,
     201,   128,   216,   220,   208,   227,   232,   213,   233,   243,
     250,   242,   244,   256,   334,   257,     1,   252,   246,   -79,
       2,   139,     3,   258,   261,     4,     5,     6,    72,     8,
     259,     9,    10,    11,    12,    13,   263,    14,   264,   279,
     267,   280,   276,   282,    15,    16,    17,    18,    19,    20,
      21,    22,   281,    23,    24,    25,   283,   284,   287,   285,
      26,    27,   296,   110,   301,   292,   293,   294,   302,    28,
     303,   300,   304,   305,   306,   338,   307,   308,   314,   315,
     321,   326,    75,    73,   289,   320,   329,   330,   332,   197,
     324,    76,   336,   210,   335,   211,   125,   212,   297,   290,
     318,   313,     0,   177
};

static const yytype_int16 yycheck[] =
{
       2,   101,    36,    35,   159,     7,    61,   196,    31,   109,
      12,    66,   131,     9,    16,    45,    11,    10,   123,    87,
       8,     8,    25,   137,    47,    46,    23,    31,    26,    27,
      51,     8,    34,    36,    46,    33,     8,    40,    61,    32,
      35,     8,    44,    47,    76,    57,     8,    49,    45,    51,
      47,    85,   107,    55,    50,   110,   175,    61,    46,    46,
       8,   161,    49,    65,    61,     8,   180,    69,    55,    46,
      72,   105,   177,   141,    46,   130,   195,    64,    65,    46,
       8,    53,    84,   183,    46,    57,     8,     8,    55,   144,
      92,    58,    94,    55,   283,   284,   285,     8,    46,   129,
      48,    49,   104,    46,   136,    53,   206,   162,    51,    57,
      53,    59,    11,    53,    57,    11,    47,    57,    46,   219,
      48,    42,   156,   125,    46,    53,    22,    55,    41,    57,
      61,    59,    28,    46,   189,    46,    35,    46,   140,    11,
     142,   143,     8,   298,   146,   245,   201,    53,   150,    55,
      22,    57,   252,    16,     8,    49,    28,    11,    12,    46,
      14,   216,   262,    17,    18,    19,    20,    21,    46,    23,
      24,    25,    26,    27,   176,    29,    46,    46,    55,    49,
      49,     6,    36,    37,    38,    39,    40,    41,    42,    43,
      54,    45,    46,    47,     0,   197,    14,    46,    52,    53,
      49,   203,    51,    48,    48,    54,   261,    61,    49,    11,
      51,    29,    51,    62,    63,    13,    50,   317,   250,    13,
      38,    39,   322,   323,    42,    55,    49,    55,    46,    50,
      44,    54,    48,    46,   334,    53,    15,   239,   293,    62,
      63,    26,    27,    16,    49,     8,    53,    15,    33,    34,
      59,    55,    48,    46,    46,    46,    56,    32,   313,   314,
      55,     8,    50,     8,    54,     8,     8,    56,    46,    49,
      10,    58,    49,     8,   329,    30,     8,   332,    48,    11,
      12,   315,    14,    11,    51,    17,    18,    19,    20,    21,
      61,    23,    24,    25,    26,    27,    56,    29,    60,     8,
      59,     8,    46,     8,    36,    37,    38,    39,    40,    41,
      42,    43,    46,    45,    46,    47,    46,    46,    56,    46,
      52,    53,    30,    49,     8,    56,    50,    50,    46,    61,
       8,    56,     8,     8,    46,   337,    46,     8,    51,    50,
      46,    56,    32,    30,   247,   299,    50,    50,    50,   135,
     315,    34,   332,   154,   330,   154,    76,   154,   259,   250,
     294,   288,    -1,   124
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     8,    12,    14,    17,    18,    19,    20,    21,    23,
      24,    25,    26,    27,    29,    36,    37,    38,    39,    40,
      41,    42,    43,    45,    46,    47,    52,    53,    61,    67,
      68,    69,    71,    72,    73,    83,    84,    85,    94,   111,
      46,    51,   111,    11,    35,    46,    31,   111,     8,   108,
      11,    35,    22,    28,   111,    16,     8,    42,    22,    28,
     111,    49,    46,    46,    86,    92,    55,    79,   113,     6,
      54,     0,    20,    72,    48,    69,    83,   111,    53,    55,
      57,    74,   100,   105,    86,    11,    41,    46,    51,    13,
     111,    79,    26,    27,    33,    50,   109,   111,    13,   111,
     111,    74,    55,    95,    96,    50,    87,    55,   111,    74,
      49,    51,   111,     8,    46,    31,     8,    46,    49,    53,
      57,    59,    70,   112,    48,   100,   103,   105,     8,    46,
      55,    58,    75,    77,   114,    44,    10,    32,   111,    86,
      88,    46,    96,    15,    49,   111,    16,   111,     8,    53,
      15,    75,     9,    50,    82,    97,    99,   111,    86,    74,
      75,    74,    55,    34,    59,     8,    46,    51,    53,    57,
      46,    57,    46,    46,    46,    48,    70,   112,   111,    56,
      32,   104,    79,    74,    77,    49,    54,    62,    63,   107,
      48,    53,    57,    59,    76,    78,    46,    73,   101,   105,
     103,    55,   111,    96,   111,   111,    74,   111,    54,   111,
      84,    85,    94,    56,    86,   114,    50,    80,    75,    74,
       8,    46,    49,    51,    54,    62,    63,     8,     8,    46,
       8,    46,     8,    46,    49,    64,    65,    77,   111,    70,
     103,    75,    58,    49,    49,    74,    48,    77,   113,   111,
      10,   102,    74,    90,   111,    75,     8,    30,    11,    61,
      98,    51,    74,    56,    60,    81,    75,    59,     8,    46,
       8,    46,    53,    57,    46,    49,    46,    46,    49,     8,
       8,    46,     8,    46,    46,    46,   111,    56,    75,    76,
     101,    75,    56,    50,    50,   110,    30,    97,    74,    75,
      56,     8,    46,     8,     8,     8,    46,    46,     8,   113,
     113,   113,   106,   107,    51,    50,    89,    74,   108,   114,
      80,    46,    74,    74,    88,    75,    56,    75,    75,    50,
      50,    93,    50,    91,    74,    92,    90,    75,   111
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *bottom, yytype_int16 *top)
#else
static void
yy_stack_print (bottom, top)
    yytype_int16 *bottom;
    yytype_int16 *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      fprintf (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      fprintf (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;
#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  yytype_int16 yyssa[YYINITDEPTH];
  yytype_int16 *yyss = yyssa;
  yytype_int16 *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     look-ahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to look-ahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 130 "AAboot.y"
    { endsrc = 1;  printf("// Reached end of program\n"); }
    break;

  case 5:
#line 137 "AAboot.y"
    { case_flip(1); }
    break;

  case 6:
#line 140 "AAboot.y"
    { case_flip(0); }
    break;

  case 19:
#line 158 "AAboot.y"
    {  printf("%5d Level = %d Enter %s\n", lineCount, ++block_count, idtable[(yyvsp[(2) - (4)])]); }
    break;

  case 20:
#line 159 "AAboot.y"
    {  printf("%5d Level = %d BEGIN\n", lineCount, ++block_count); }
    break;

  case 21:
#line 160 "AAboot.y"
    {  printf("%5d Level = %d END\n", lineCount, --block_count); }
    break;

  case 97:
#line 290 "AAboot.y"
    { formal_pars = 1; }
    break;

  case 98:
#line 292 "AAboot.y"
    { formal_pars = 0; }
    break;

  case 134:
#line 366 "AAboot.y"
    { printf("Funny * %s :\n", idtable[(yyvsp[(1) - (2)])]); }
    break;

  case 135:
#line 368 "AAboot.y"
    { onenum((yyvsp[(1) - (3)]), (yyvsp[(2) - (3)])); }
    break;

  case 136:
#line 369 "AAboot.y"
    { onenum(idtablocate(idtable[(yyvsp[(1) - (3)])], (yyvsp[(2) - (3)])), (yyvsp[(3) - (3)])); }
    break;

  case 141:
#line 376 "AAboot.y"
    { nonums((yyvsp[(1) - (1)])); }
    break;

  case 142:
#line 377 "AAboot.y"
    { nonums(idtablocate("=", (yyvsp[(2) - (2)]))); }
    break;

  case 143:
#line 378 "AAboot.y"
    { onenum((yyvsp[(1) - (2)]), (yyvsp[(2) - (2)])); }
    break;

  case 144:
#line 379 "AAboot.y"
    { onenum(idtablocate("=", (yyvsp[(2) - (3)])), (yyvsp[(3) - (3)])); }
    break;

  case 145:
#line 380 "AAboot.y"
    { onenum(idtablocate("=+", (yyvsp[(3) - (4)])), (yyvsp[(4) - (4)])); }
    break;

  case 146:
#line 382 "AAboot.y"
    { twonums(idtablocate(idtable[(yyvsp[(1) - (4)])], (yyvsp[(3) - (4)])), (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)])); }
    break;

  case 147:
#line 384 "AAboot.y"
    { twonums(idtablocate2("=", (yyvsp[(2) - (5)]), (yyvsp[(4) - (5)]), -1), (yyvsp[(3) - (5)]), (yyvsp[(5) - (5)])); }
    break;

  case 148:
#line 387 "AAboot.y"
    { twonums(idtablocate2(idtable[(yyvsp[(1) - (5)])], (yyvsp[(3) - (5)]), (yyvsp[(5) - (5)]), -1), (yyvsp[(2) - (5)]), (yyvsp[(4) - (5)])); }
    break;

  case 149:
#line 389 "AAboot.y"
    { twonums(idtablocate2("=", (yyvsp[(2) - (6)]), (yyvsp[(4) - (6)]), (yyvsp[(6) - (6)])), (yyvsp[(3) - (6)]), (yyvsp[(5) - (6)])); }
    break;

  case 150:
#line 392 "AAboot.y"
    { twonums(idtablocate2(idtable[(yyvsp[(1) - (5)])], (yyvsp[(3) - (5)]), (yyvsp[(4) - (5)]), -1), (yyvsp[(2) - (5)]), (yyvsp[(5) - (5)])); }
    break;

  case 151:
#line 395 "AAboot.y"
    { onenum((yyvsp[(1) - (3)]), -(yyvsp[(3) - (3)])); }
    break;

  case 152:
#line 396 "AAboot.y"
    { onenum((yyvsp[(1) - (3)]), (yyvsp[(3) - (3)])); }
    break;

  case 153:
#line 398 "AAboot.y"
    { justaddr(jumptest((yyvsp[(1) - (4)]), (yyvsp[(4) - (4)]), "JEQZ"), codeloc((yyvsp[(2) - (4)]))); }
    break;

  case 154:
#line 399 "AAboot.y"
    { justaddr(jumptest((yyvsp[(1) - (4)]), (yyvsp[(4) - (4)]), "JGTZ"), codeloc((yyvsp[(2) - (4)]))); }
    break;

  case 155:
#line 400 "AAboot.y"
    { justaddr(jumptest((yyvsp[(1) - (5)]), (yyvsp[(5) - (5)]), "JGEZ"), codeloc((yyvsp[(2) - (5)]))); }
    break;

  case 156:
#line 401 "AAboot.y"
    { justaddr(jumptest((yyvsp[(1) - (5)]), (yyvsp[(5) - (5)]), "JLEZ"), codeloc((yyvsp[(2) - (5)]))); }
    break;

  case 157:
#line 402 "AAboot.y"
    { justaddr(jumptest((yyvsp[(1) - (4)]), (yyvsp[(4) - (4)]), "JLTZ"), codeloc((yyvsp[(2) - (4)]))); }
    break;

  case 158:
#line 403 "AAboot.y"
    { justaddr(jumptest((yyvsp[(1) - (4)]), (yyvsp[(4) - (4)]), "JNEZ"), codeloc((yyvsp[(2) - (4)]))); }
    break;

  case 159:
#line 404 "AAboot.y"
    { justaddr(jumptest((yyvsp[(1) - (3)]), justz, "JNE"), codeloc((yyvsp[(2) - (3)]))); }
    break;

  case 160:
#line 405 "AAboot.y"
    { justaddr(jumptest((yyvsp[(1) - (3)]), justz, "JEQ"), codeloc((yyvsp[(2) - (3)]))); }
    break;

  case 161:
#line 406 "AAboot.y"
    { onenum(idtablocate(idtable[(yyvsp[(1) - (3)])], (yyvsp[(3) - (3)])), (yyvsp[(2) - (3)])); }
    break;

  case 162:
#line 408 "AAboot.y"
    { nonums(tablocate("-")); }
    break;

  case 163:
#line 409 "AAboot.y"
    { nonums(idtablocate("-", (yyvsp[(2) - (2)]))); }
    break;

  case 164:
#line 410 "AAboot.y"
    { nonums(tablocate("+")); }
    break;

  case 165:
#line 411 "AAboot.y"
    { nonums(idtablocate("+", (yyvsp[(2) - (2)]))); }
    break;

  case 166:
#line 412 "AAboot.y"
    { nonums(tablocate("DIV")); }
    break;

  case 167:
#line 413 "AAboot.y"
    { nonums(idtablocate("DIV", (yyvsp[(2) - (2)]))); }
    break;

  case 168:
#line 414 "AAboot.y"
    { mpmi((yyvsp[(1) - (4)]), '-', (yyvsp[(3) - (4)]), (yyvsp[(4) - (4)])); }
    break;

  case 169:
#line 415 "AAboot.y"
    { mpmi((yyvsp[(1) - (4)]), '+', (yyvsp[(3) - (4)]), (yyvsp[(4) - (4)])); }
    break;

  case 170:
#line 417 "AAboot.y"
    { setinc((yyvsp[(1) - (5)]), (yyvsp[(2) - (5)]), -(yyvsp[(5) - (5)])); }
    break;

  case 171:
#line 418 "AAboot.y"
    { setinc((yyvsp[(1) - (5)]), (yyvsp[(2) - (5)]), (yyvsp[(5) - (5)])); }
    break;

  case 172:
#line 419 "AAboot.y"
    { setinc((yyvsp[(1) - (4)]), (yyvsp[(2) - (4)]), (yyvsp[(4) - (4)])); }
    break;

  case 173:
#line 421 "AAboot.y"
    { qval((yyvsp[(1) - (5)]), (yyvsp[(3) - (5)]), (yyvsp[(5) - (5)])); }
    break;

  case 174:
#line 424 "AAboot.y"
    { startnewword(1); }
    break;


/* Line 1267 of yacc.c.  */
#line 2014 "y.tab.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}


#line 433 "AAboot.y"



